Index: trunk/src/VBox/HostServices/SharedOpenGL/HostOGLComplexAsync.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedOpenGL/HostOGLComplexAsync.cpp	(revision 3697)
+++ trunk/src/VBox/HostServices/SharedOpenGL/HostOGLComplexAsync.cpp	(revision 3698)
@@ -4,5 +4,7 @@
  *
  * Complex buffered OpenGL functions
- *
+ */
+
+/*
  * Copyright (C) 2006-2007 innotek GmbH
  *
Index: trunk/src/VBox/HostServices/SharedOpenGL/HostOGLComplexSync.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedOpenGL/HostOGLComplexSync.cpp	(revision 3697)
+++ trunk/src/VBox/HostServices/SharedOpenGL/HostOGLComplexSync.cpp	(revision 3698)
@@ -4,5 +4,7 @@
  *
  * Simple buffered OpenGL functions
- *
+ */
+
+/*
  * Copyright (C) 2006-2007 innotek GmbH
  *
@@ -44,5 +46,5 @@
 
 /* Note: when in GL_FEEDBACK or GL_SELECT mode -> fill those buffers
- *       when switching to GL_FEEDBACK or GL_SELECT mode -> pass pointers 
+ *       when switching to GL_FEEDBACK or GL_SELECT mode -> pass pointers
  */
 void vboxglRenderMode (VBOXOGLCTX *pClient, uint8_t *pCmdBuffer)
Index: trunk/src/VBox/HostServices/SharedOpenGL/HostOGLSimpleAsync.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedOpenGL/HostOGLSimpleAsync.cpp	(revision 3697)
+++ trunk/src/VBox/HostServices/SharedOpenGL/HostOGLSimpleAsync.cpp	(revision 3698)
@@ -4,5 +4,7 @@
  *
  * Simple buffered OpenGL functions
- *
+ */
+
+/*
  * Copyright (C) 2006-2007 innotek GmbH
  *
Index: trunk/src/VBox/HostServices/SharedOpenGL/HostOGLSimpleSync.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedOpenGL/HostOGLSimpleSync.cpp	(revision 3697)
+++ trunk/src/VBox/HostServices/SharedOpenGL/HostOGLSimpleSync.cpp	(revision 3698)
@@ -4,5 +4,7 @@
  *
  * Simple buffered OpenGL functions
- *
+ */
+
+/*
  * Copyright (C) 2006-2007 innotek GmbH
  *
Index: trunk/src/VBox/HostServices/SharedOpenGL/gldrv.h
===================================================================
--- trunk/src/VBox/HostServices/SharedOpenGL/gldrv.h	(revision 3697)
+++ trunk/src/VBox/HostServices/SharedOpenGL/gldrv.h	(revision 3698)
@@ -1,4 +1,3 @@
 /** @file
- *
  * VBox OpenGL windows helper functions
  */
@@ -20,10 +19,10 @@
  */
 
-#ifndef __VBOXGLWIN__H
-#define __VBOXGLWIN__H
+#ifndef ___VBOXGLWIN_H
+#define ___VBOXGLWIN_H
 
 #include <iprt/types.h>
 
-#ifdef __WIN__
+#ifdef RT_OS_WINDOWS
 #define VBOX_OGL_DEBUG_WINDOW_OUTPUT
 #endif
@@ -52,5 +51,5 @@
 
 
-#ifndef __WIN__
+#ifndef RT_OS_WINDOWS
 
 typedef uint32_t    DWORD;
@@ -153,3 +152,3 @@
 RTUINTPTR vboxDrvIsExtensionAvailable(char *pszExtFunctionName);
 
-#endif /* __VBOXGLWIN__H */
+#endif /* !___VBOXGLWIN_H */
Index: trunk/src/VBox/HostServices/SharedOpenGL/glext.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedOpenGL/glext.cpp	(revision 3697)
+++ trunk/src/VBox/HostServices/SharedOpenGL/glext.cpp	(revision 3698)
@@ -3,8 +3,11 @@
  * VBox OpenGL helper functions
  *
- * OpenGL extensions 
+ * OpenGL extensions
  *
  * References:  http://oss.sgi.com/projects/ogl-sample/registry/
  *              http://icps.u-strasbg.fr/~marchesin/perso/extensions/
+ */
+
+/*
  *
  * Copyright (C) 2006-2007 innotek GmbH
@@ -78,5 +81,5 @@
 }
 
-#ifdef __WIN__
+#ifdef RT_OS_WINDOWS
 void vboxwglSwapIntervalEXT (VBOXOGLCTX *pClient, uint8_t *pCmdBuffer)
 {
@@ -105,3 +108,3 @@
     pClient->ulLastError   = GetLastError();
 }
-#endif /* __WIN__ */
+#endif /* RT_OS_WINDOWS */
Index: trunk/src/VBox/HostServices/SharedOpenGL/gllindrv.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedOpenGL/gllindrv.cpp	(revision 3697)
+++ trunk/src/VBox/HostServices/SharedOpenGL/gllindrv.cpp	(revision 3698)
@@ -4,5 +4,7 @@
  *
  * Simple buffered OpenGL functions
- *
+ */
+
+/*
  * Copyright (C) 2006-2007 innotek GmbH
  *
Index: trunk/src/VBox/HostServices/SharedOpenGL/glwindrv.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedOpenGL/glwindrv.cpp	(revision 3697)
+++ trunk/src/VBox/HostServices/SharedOpenGL/glwindrv.cpp	(revision 3698)
@@ -1,4 +1,3 @@
 /** @file
- *
  * VBox OpenGL
  */
@@ -36,5 +35,5 @@
 {
     switch (message)
-    {		
+    {
     case WM_CREATE:
         return 0;
@@ -48,5 +47,5 @@
 
     default:
-        return DefWindowProc( hWnd, message, wParam, lParam );			
+        return DefWindowProc( hWnd, message, wParam, lParam );
     }
 }
@@ -57,8 +56,8 @@
     HWND        hwnd;
 
-    hwnd = pClient->hwnd= CreateWindow("VBoxOGL", "VirtualBox OpenGL", 
+    hwnd = pClient->hwnd= CreateWindow("VBoxOGL", "VirtualBox OpenGL",
 		                               WS_CAPTION | WS_POPUPWINDOW | WS_VISIBLE,
 		                               0, 0, 0, 0,
-        	                        NULL, NULL, 0, NULL);	
+        	                        NULL, NULL, 0, NULL);
     Assert(hwnd);
     while(true)
@@ -68,5 +67,5 @@
         if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
         {
-            if (msg.message == WM_QUIT) 
+            if (msg.message == WM_QUIT)
                 break;
 
Index: trunk/src/VBox/HostServices/SharedOpenGL/vboxgl.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedOpenGL/vboxgl.cpp	(revision 3697)
+++ trunk/src/VBox/HostServices/SharedOpenGL/vboxgl.cpp	(revision 3698)
@@ -1,4 +1,3 @@
 /** @file
- *
  * VBox OpenGL
  */
@@ -49,5 +48,5 @@
     int      rc = VINF_SUCCESS;
 
-#ifdef __WIN__
+#ifdef RT_OS_WINDOWS
     PIXELFORMATDESCRIPTOR pfd;
     int iFormat;
@@ -88,5 +87,5 @@
 end:
 
-#ifdef __WIN__
+#ifdef RT_OS_WINDOWS
     wglMakeCurrent(NULL, NULL);
     wglDeleteContext(hRC);
Index: trunk/src/VBox/HostServices/SharedOpenGL/vboxgl.h
===================================================================
--- trunk/src/VBox/HostServices/SharedOpenGL/vboxgl.h	(revision 3697)
+++ trunk/src/VBox/HostServices/SharedOpenGL/vboxgl.h	(revision 3698)
@@ -1,4 +1,3 @@
 /** @file
- *
  * VBox OpenGL helper functions
  */
@@ -20,8 +19,8 @@
  */
 
-#ifndef __VBOGL__H
-#define __VBOGL__H
-
-#ifdef __WIN__
+#ifndef ___VBOGL_H
+#define ___VBOGL_H
+
+#ifdef RT_OS_WINDOWS
 #include <windows.h>
 #endif
@@ -60,5 +59,5 @@
  *
  * @returns VBox error code
- * @param   pClient     
+ * @param   pClient
  * @param   name        glGetString name parameter
  * @param   pString     String pointer
@@ -360,3 +359,3 @@
 #include <VBox/HostServices/VBoxOGLOp.h>
 
-#endif /* __VBOGL__H */
+#endif /* !___VBOGL_H */