Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ar.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ar.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ar.ts	(revision 3829)
@@ -3926,9 +3926,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <source>Floppy image file is not selected.</source>
         <translation type="unfinished"></translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 3829)
@@ -3890,9 +3890,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
         <translation>CD/DVD-ROM-Abbild ist nicht ausgewählt.</translation>
     </message>
     <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>Floppy image file is not selected.</source>
         <translation>Diskettenabbild ist nicht ausgewählt.</translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts	(revision 3829)
@@ -4086,9 +4086,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <source>Floppy image file is not selected.</source>
         <translation type="unfinished"></translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fi.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fi.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fi.ts	(revision 3829)
@@ -3875,9 +3875,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
         <translation>CD/DVD:n levykuva tiedostoa ei ole valittu.</translation>
     </message>
     <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>Floppy image file is not selected.</source>
         <translation>Levykkeen levykuva tiedostoa ei ole valittu.</translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts	(revision 3829)
@@ -4306,9 +4306,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
         <translation>Image CD/DVD non sélectionnée.</translation>
     </message>
     <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>Floppy image file is not selected.</source>
         <translation>Image disquette non sélectionnée.</translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts	(revision 3829)
@@ -3989,9 +3989,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <source>Floppy image file is not selected.</source>
         <translation type="unfinished"></translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_it.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_it.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_it.ts	(revision 3829)
@@ -4404,9 +4404,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
         <translation>Il file immagine CD/DVD non è stato selezionato.</translation>
     </message>
     <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>Floppy image file is not selected.</source>
         <translation>Il file immagine floppy non è stato selezionato.</translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ja.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ja.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ja.ts	(revision 3829)
@@ -3963,9 +3963,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
         <translation>CD/DVDイメージファイルが選択されていません。</translation>
     </message>
     <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>Floppy image file is not selected.</source>
         <translation>フロッピーイメージファイルが選択されていません。</translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ko.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ko.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ko.ts	(revision 3829)
@@ -3931,9 +3931,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
         <translation>CD/DVD 이미지 파일이 선택되지 않았습니다.</translation>
     </message>
     <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>Floppy image file is not selected.</source>
         <translation>플로피 드라이브 이미지 파일이 선택되지 않았습니다.</translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pl.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pl.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pl.ts	(revision 3829)
@@ -3981,9 +3981,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
         <translation>Obraz nośnika CD/DVD nie został wybrany.</translation>
     </message>
     <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>Floppy image file is not selected.</source>
         <translation>Obraz dyskietki nie został wybrany.</translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt_BR.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt_BR.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt_BR.ts	(revision 3829)
@@ -3987,9 +3987,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
         <translation>O arquivo de imagem de CD/DVD não está selecionado.</translation>
     </message>
     <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>Floppy image file is not selected.</source>
         <translation>O arquivo de imagem de disquete não está selecionado.</translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ro.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ro.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ro.ts	(revision 3829)
@@ -4394,9 +4394,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
         <translation>Fişierul imagine de CD/DVD nu este selectat.</translation>
     </message>
     <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>Floppy image file is not selected.</source>
         <translation>Fişierul imagine dischetă nu este selectat.</translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 3829)
@@ -3945,9 +3945,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
         <translation>Не выбран файл образа CD/DVD.</translation>
     </message>
     <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>Floppy image file is not selected.</source>
         <translation>Не выбран файл образа дискеты.</translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sv.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sv.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sv.ts	(revision 3829)
@@ -3948,9 +3948,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
         <translation>Avbildsfil för CD/DVD-enhet har inte valts.</translation>
     </message>
     <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>Floppy image file is not selected.</source>
         <translation>Avbildsfil för diskettenhet har inte valts.</translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts	(revision 3829)
@@ -3875,9 +3875,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <source>Floppy image file is not selected.</source>
         <translation type="unfinished"></translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_CN.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_CN.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_CN.ts	(revision 3829)
@@ -4219,9 +4219,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
         <translation>没有指定虚拟电脑上使用的光盘映像文件.</translation>
     </message>
     <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>Floppy image file is not selected.</source>
         <translation>没有指定虚拟电脑上使用的软盘映像.</translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_TW.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_TW.ts	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_TW.ts	(revision 3829)
@@ -5101,9 +5101,9 @@
     </message>
     <message>
-        <source>CD/DVD drive image file is not selected.</source>
+        <source>CD/DVD image file is not selected.</source>
         <translation>尚未選取光碟映像檔。</translation>
     </message>
     <message>
-        <source>Floppy drive image file is not selected.</source>
+        <source>Floppy image file is not selected.</source>
         <translation>尚未選取軟碟映像檔。</translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui.h	(revision 3828)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui.h	(revision 3829)
@@ -1421,5 +1421,5 @@
 
         if (!valid)
-            setWarning (tr ("CD/DVD drive image file is not selected."));
+            setWarning (tr ("CD/DVD image file is not selected."));
     }
     else if (pg == pageFloppy)
@@ -1438,5 +1438,5 @@
 
         if (!valid)
-            setWarning (tr ("Floppy drive image file is not selected."));
+            setWarning (tr ("Floppy image file is not selected."));
     }
     else if (pg == pageNetwork)